Index: /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4647)
+++ /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4648)
@@ -3069,20 +2981,18 @@
 
 !
-!--    If less particles are stored on the restart file than prescribed by
-!--    1, the remainder is initialized by zero_particle to avoid
-!--    errors.
-       zero_particle = particle_type( 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp,     &
-                                      0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp,     &
-                                      0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp,     &
-                                      0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp,     &
+!--    If less particles are stored on the restart file than prescribed by 1, the remainder is
+!--    initialized by zero_particle to avoid errors.
+       zero_particle = particle_type( 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp,                      &
+                                      0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp,                      &
+                                      0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp,                      &
+                                      0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp,                      &
                                       0, 0, 0_idp, .FALSE., -1, -1 )
 !
-!--    Read some particle parameters and the size of the particle arrays,
-!--    allocate them and read their contents.
-       READ ( 90 )  bc_par_b, bc_par_lr, bc_par_ns, bc_par_t,                     &
-                    last_particle_release_time, number_of_particle_groups,        &
-                    particle_groups, time_write_particle_data
-
-       ALLOCATE( prt_count(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                        &
+!--    Read some particle parameters and the size of the particle arrays, allocate them and read
+!--    their contents.
+       READ ( 90 )  bc_par_b, bc_par_lr, bc_par_ns, bc_par_t, last_particle_release_time,          &
+                    number_of_particle_groups, particle_groups, time_write_particle_data
+
+       ALLOCATE( prt_count(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                         &
                  grid_particles(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 
@@ -3095,7 +3005,7 @@
                 number_of_particles = prt_count(kp,jp,ip)
                 IF ( number_of_particles > 0 )  THEN
-                   alloc_size = MAX( INT( number_of_particles *                   &
-                                ( 1.0_wp + alloc_factor / 100.0_wp ) ),           &
-                                1 )
+                   alloc_size = MAX( INT( number_of_particles *                                    &
+                                          ( 1.0_wp + alloc_factor / 100.0_wp ) ),                  &
+                                     1 )
                 ELSE
                    alloc_size = 1
@@ -3110,5 +3020,5 @@
                    DEALLOCATE( tmp_particles )
                    IF ( number_of_particles < alloc_size )  THEN
-                      grid_particles(kp,jp,ip)%particles(number_of_particles+1:alloc_size) &
+                      grid_particles(kp,jp,ip)%particles(number_of_particles+1:alloc_size)         &
                          = zero_particle
                    ENDIF
@@ -3128,11 +3038,10 @@
        FLUSH(9)
 
-       ALLOCATE( prt_count(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                        &
+       ALLOCATE( prt_count(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                         &
                  grid_particles(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 
        ALLOCATE( prt_global_index(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 !
-!--    Open restart file for read, if not already open, and do not allow usage of
-!--    shared-memory I/O
+!--    Open restart file for read, if not already open, and do not allow usage of shared-memory I/O
        IF ( .NOT. rd_mpi_io_check_open() )  THEN
           save_restart_data_format_input = restart_data_format_input
@@ -3156,7 +3065,7 @@
                 number_of_particles = prt_count(kp,jp,ip)
                 IF ( number_of_particles > 0 )  THEN
-                   alloc_size = MAX( INT( number_of_particles *                   &
-                      ( 1.0_wp + alloc_factor / 100.0_wp ) ),           &
-                      1 )
+                   alloc_size = MAX( INT( number_of_particles *                                    &
+                                          ( 1.0_wp + alloc_factor / 100.0_wp ) ),                  &
+                                     1 )
                 ELSE
                    alloc_size = 1
@@ -3186,22 +3095,21 @@
     ENDIF
 !
-!-- Must be called to sort particles into blocks, which is needed for a fast
-!-- interpolation of the LES fields on the particle position.
+!-- Must be called to sort particles into blocks, which is needed for a fast interpolation of the
+!-- LES fields on the particle position.
     CALL lpm_sort_and_delete
 
  END SUBROUTINE lpm_rrd_local_particles
- 
- 
-!------------------------------------------------------------------------------!
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Read module-specific local restart data arrays (Fortran binary format).
-!------------------------------------------------------------------------------!
- SUBROUTINE lpm_rrd_local_ftn( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,          &
-                               nxr_on_file, nynf, nync, nyn_on_file, nysf,  &
-                               nysc, nys_on_file, tmp_3d, found )
-
-
-   USE control_parameters,                                                 &
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE lpm_rrd_local_ftn( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc, nxr_on_file, nynf, nync,    &
+                               nyn_on_file, nysf, nysc, nys_on_file, tmp_3d, found )
+
+
+   USE control_parameters,                                                                         &
        ONLY: length, restart_string
 
@@ -3220,7 +3128,8 @@
     INTEGER(iwp) ::  nys_on_file     !<
 
+    INTEGER(isp), DIMENSION(:,:,:), ALLOCATABLE ::  tmp_2d_seq_random_particles  !< temporary array for storing random generator
+                                                                                 !< data for the lpm
+
     LOGICAL, INTENT(OUT)  ::  found
-
-    INTEGER(isp), DIMENSION(:,:,:), ALLOCATABLE ::  tmp_2d_seq_random_particles  !< temporary array for storing random generator data for the lpm
 
     REAL(wp), DIMENSION(nzb:nzt+1,nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) ::  tmp_3d   !<
@@ -3236,5 +3145,5 @@
            ENDIF
            IF ( k == 1 )  READ ( 13 )  tmp_3d
-           pc_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =          &
+           pc_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =                                      &
               tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
@@ -3244,7 +3153,7 @@
            ENDIF
            IF ( k == 1 )  READ ( 13 )  tmp_3d
-           pr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =          &
+           pr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =                                      &
               tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
- 
+
          CASE ( 'ql_c_av' )
             IF ( .NOT. ALLOCATED( ql_c_av ) )  THEN
@@ -3252,5 +3161,5 @@
             ENDIF
             IF ( k == 1 )  READ ( 13 )  tmp_3d
-            ql_c_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =        &
+            ql_c_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =                                   &
                tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
@@ -3260,5 +3169,5 @@
             ENDIF
             IF ( k == 1 )  READ ( 13 )  tmp_3d
-            ql_v_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =        &
+            ql_v_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =                                   &
                tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
@@ -3268,16 +3177,16 @@
             ENDIF
             IF ( k == 1 )  READ ( 13 )  tmp_3d
-            ql_vp_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =       &
+            ql_vp_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =                                  &
                tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
          CASE ( 'seq_random_array_particles' )
-             ALLOCATE( tmp_2d_seq_random_particles(5,nys_on_file:nyn_on_file,nxl_on_file:nxr_on_file) )
-             IF ( .NOT. ALLOCATED( seq_random_array_particles ) )  THEN
-                ALLOCATE( seq_random_array_particles(5,nys:nyn,nxl:nxr) )
-             ENDIF
-             IF ( k == 1 )  READ ( 13 )  tmp_2d_seq_random_particles
-             seq_random_array_particles(:,nysc:nync,nxlc:nxrc) =                                   &
-                                                  tmp_2d_seq_random_particles(:,nysf:nynf,nxlf:nxrf)
-             DEALLOCATE( tmp_2d_seq_random_particles )
+            ALLOCATE( tmp_2d_seq_random_particles(5,nys_on_file:nyn_on_file,nxl_on_file:nxr_on_file) )
+            IF ( .NOT. ALLOCATED( seq_random_array_particles ) )  THEN
+               ALLOCATE( seq_random_array_particles(5,nys:nyn,nxl:nxr) )
+            ENDIF
+            IF ( k == 1 )  READ ( 13 )  tmp_2d_seq_random_particles
+            seq_random_array_particles(:,nysc:nync,nxlc:nxrc) =                                    &
+                                                 tmp_2d_seq_random_particles(:,nysf:nynf,nxlf:nxrf)
+            DEALLOCATE( tmp_2d_seq_random_particles )
 
           CASE DEFAULT
@@ -3289,10 +3198,10 @@
  END SUBROUTINE lpm_rrd_local_ftn
 
- 
-!------------------------------------------------------------------------------!
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Read module-specific local restart data arrays (MPI-IO).
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE lpm_rrd_local_mpi
 
@@ -3349,11 +3258,11 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> This routine writes the respective restart data for the lpm.
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE lpm_wrd_local
- 
+
     CHARACTER (LEN=10) ::  particle_binary_version   !<
     CHARACTER (LEN=32) ::  tmp_name                  !< temporary variable
@@ -3364,5 +3273,5 @@
     INTEGER(iwp) ::  jp                              !<
     INTEGER(iwp) ::  k                               !< loop index
-    INTEGER(iwp) ::  kp                              !< 
+    INTEGER(iwp) ::  kp                              !<
 
 #if defined( __parallel )
@@ -3382,25 +3291,21 @@
 !--    First open the output unit.
        IF ( myid_char == '' )  THEN
-          OPEN ( 90, FILE='PARTICLE_RESTART_DATA_OUT'//myid_char, &
-                     FORM='UNFORMATTED')
+          OPEN ( 90, FILE='PARTICLE_RESTART_DATA_OUT'//myid_char, FORM='UNFORMATTED')
        ELSE
           IF ( myid == 0 )  CALL local_system( 'mkdir PARTICLE_RESTART_DATA_OUT' )
 #if defined( __parallel )
 !
-!--       Set a barrier in order to allow that thereafter all other processors
-!--       in the directory created by PE0 can open their file
+!--       Set a barrier in order to allow that thereafter all other processors in the directory
+!--       created by PE0 can open their file
           CALL MPI_BARRIER( comm2d, ierr )
 #endif
-          OPEN ( 90, FILE='PARTICLE_RESTART_DATA_OUT/'//myid_char, &
-                     FORM='UNFORMATTED' )
+          OPEN ( 90, FILE='PARTICLE_RESTART_DATA_OUT/'//myid_char, FORM='UNFORMATTED' )
        ENDIF
 
 !
 !--    Write the version number of the binary format.
-!--    Attention: After changes to the following output commands the version
-!--    ---------  number of the variable particle_binary_version must be
-!--               changed! Also, the version number and the list of arrays
-!--               to be read in lpm_read_restart_file must be adjusted
-!--               accordingly.
+!--    Attention: After changes to the following output commands the version number of the variable
+!--    ---------  particle_binary_version must be changed! Also, the version number and the list of
+!--               arrays to be read in lpm_read_restart_file must be adjusted accordingly.
        particle_binary_version = '4.0'
        WRITE ( 90 )  particle_binary_version
@@ -3408,10 +3313,9 @@
 !
 !--    Write some particle parameters, the size of the particle arrays
-       WRITE ( 90 )  bc_par_b, bc_par_lr, bc_par_ns, bc_par_t,                    &
-                     last_particle_release_time, number_of_particle_groups,       &
-                     particle_groups, time_write_particle_data
+       WRITE ( 90 )  bc_par_b, bc_par_lr, bc_par_ns, bc_par_t, last_particle_release_time,         &
+                     number_of_particle_groups, particle_groups, time_write_particle_data
 
        WRITE ( 90 )  prt_count
-          
+
        DO  ip = nxl, nxr
           DO  jp = nys, nyn
@@ -3465,6 +3369,6 @@
 
 #if defined( __parallel )
-       CALL MPI_ALLREDUCE( nr_particles_local, nr_particles_global, numprocs, MPI_INTEGER,         &
-                           MPI_SUM, comm2d, ierr )
+       CALL MPI_ALLREDUCE( nr_particles_local, nr_particles_global, numprocs, MPI_INTEGER, MPI_SUM,&
+                           comm2d, ierr )
 #else
        nr_particles_global = nr_particles_local
@@ -3500,9 +3404,9 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> This routine writes the respective restart data for the lpm.
-!------------------------------------------------------------------------------! 
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE lpm_wrd_global
 
@@ -3513,5 +3417,5 @@
     REAL(wp), DIMENSION(4,max_number_of_particle_groups) ::  particle_groups_array  !<
 
- 
+
     IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
 
@@ -3569,14 +3473,14 @@
 
  END SUBROUTINE lpm_wrd_global
- 
-
-!------------------------------------------------------------------------------!
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Read module-specific global restart data (Fortran binary format).
-!------------------------------------------------------------------------------! 
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE lpm_rrd_global_ftn( found )
- 
-    USE control_parameters,                            &
+
+    USE control_parameters,                                                                        &
         ONLY: length, restart_string
 
@@ -3603,14 +3507,14 @@
           found = .FALSE.
 
-    END SELECT 
-    
+    END SELECT
+
  END SUBROUTINE lpm_rrd_global_ftn
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Read module-specific global restart data (MPI-IO).
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE lpm_rrd_global_mpi
 
@@ -3661,15 +3565,19 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> This is a submodule of the lagrangian particle model. It contains all 
-!> dynamic processes of the lpm. This includes the advection (resolved and sub-
-!> grid scale) as well as the boundary conditions of particles. As a next step
-!> this submodule should be excluded as an own file. 
-!------------------------------------------------------------------------------!
+!> This is a submodule of the lagrangian particle model. It contains all dynamic processes of the
+!> lpm. This includes the advection (resolved and sub-grid scale) as well as the boundary conditions
+!> of particles. As a next step this submodule should be excluded as an own file.
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE lpm_advec (ip,jp,kp)
 
-    LOGICAL ::  subbox_at_wall !< flag to see if the current subgridbox is adjacent to a wall
+    REAL(wp), PARAMETER ::  a_rog = 9.65_wp      !< parameter for fall velocity
+    REAL(wp), PARAMETER ::  b_rog = 10.43_wp     !< parameter for fall velocity
+    REAL(wp), PARAMETER ::  c_rog = 0.6_wp       !< parameter for fall velocity
+    REAL(wp), PARAMETER ::  k_cap_rog = 4.0_wp   !< parameter for fall velocity
+    REAL(wp), PARAMETER ::  k_low_rog = 12.0_wp  !< parameter for fall velocity
+    REAL(wp), PARAMETER ::  d0_rog = 0.745_wp    !< separation diameter
 
     INTEGER(iwp) ::  i                           !< index variable along x
@@ -3681,5 +3589,5 @@
     INTEGER(iwp) ::  jp                          !< index variable along y
     INTEGER(iwp) ::  k                           !< index variable along z
-    INTEGER(iwp) ::  k_wall                      !< vertical index of topography top 
+    INTEGER(iwp) ::  k_wall                      !< vertical index of topography top
     INTEGER(iwp) ::  kp                          !< index variable along z
     INTEGER(iwp) ::  k_next                      !< index variable along z
@@ -3687,4 +3595,5 @@
     INTEGER(iwp) ::  kkw                         !< index variable along z
     INTEGER(iwp) ::  n                           !< loop variable over all particles in a grid box
+    INTEGER(iwp) ::  nn                          !< loop variable over iterations steps
     INTEGER(iwp) ::  nb                          !< block number particles are sorted in
     INTEGER(iwp) ::  particle_end                !< end index for partilce loop
@@ -3692,17 +3601,17 @@
     INTEGER(iwp) ::  subbox_end                  !< end index for loop over subboxes in particle advection
     INTEGER(iwp) ::  subbox_start                !< start index for loop over subboxes in particle advection
-    INTEGER(iwp) ::  nn                          !< loop variable over iterations steps
-
+
+    INTEGER(iwp), DIMENSION(0:7) ::  end_index   !< start particle index for current block
     INTEGER(iwp), DIMENSION(0:7) ::  start_index !< start particle index for current block
-    INTEGER(iwp), DIMENSION(0:7) ::  end_index   !< start particle index for current block
+
+    LOGICAL ::  subbox_at_wall !< flag to see if the current subgridbox is adjacent to a wall
 
     REAL(wp) ::  aa                 !< dummy argument for horizontal particle interpolation
     REAL(wp) ::  alpha              !< interpolation facor for x-direction
-
     REAL(wp) ::  bb                 !< dummy argument for horizontal particle interpolation
     REAL(wp) ::  beta               !< interpolation facor for y-direction
     REAL(wp) ::  cc                 !< dummy argument for horizontal particle interpolation
-    REAL(wp) ::  d_z_p_z0           !< inverse of interpolation length for logarithmic interpolation 
-    REAL(wp) ::  dd                 !< dummy argument for horizontal particle interpolation 
+    REAL(wp) ::  d_z_p_z0           !< inverse of interpolation length for logarithmic interpolation
+    REAL(wp) ::  dd                 !< dummy argument for horizontal particle interpolation
     REAL(wp) ::  de_dx_int_l        !< x/y-interpolated TKE gradient (x) at particle position at lower vertical level
     REAL(wp) ::  de_dx_int_u        !< x/y-interpolated TKE gradient (x) at particle position at upper vertical level
@@ -3724,8 +3633,8 @@
     REAL(wp) ::  exp_term           !< exponent term
     REAL(wp) ::  gamma              !< interpolation facor for z-direction
-    REAL(wp) ::  gg                 !< dummy argument for horizontal particle interpolation 
+    REAL(wp) ::  gg                 !< dummy argument for horizontal particle interpolation
     REAL(wp) ::  height_p           !< dummy argument for logarithmic interpolation
     REAL(wp) ::  log_z_z0_int       !< logarithmus used for surface_layer interpolation
-    REAL(wp) ::  RL                 !< Lagrangian autocorrelation coefficient
+    REAL(wp) ::  rl                 !< Lagrangian autocorrelation coefficient
     REAL(wp) ::  rg1                !< Gaussian distributed random number
     REAL(wp) ::  rg2                !< Gaussian distributed random number
@@ -3739,10 +3648,10 @@
     REAL(wp) ::  v_int_u            !< x/y-interpolated v-component at particle position at upper vertical level
     REAL(wp) ::  vnext              !< calculated particle v-velocity of corrector step
-    REAL(wp) ::  vv_int             !< dummy to compute interpolated mean SGS TKE, used to scale SGS advection 
+    REAL(wp) ::  vv_int             !< dummy to compute interpolated mean SGS TKE, used to scale SGS advection
     REAL(wp) ::  w_int_l            !< x/y-interpolated w-component at particle position at lower vertical level
     REAL(wp) ::  w_int_u            !< x/y-interpolated w-component at particle position at upper vertical level
     REAL(wp) ::  wnext              !< calculated particle w-velocity of corrector step
     REAL(wp) ::  w_s                !< terminal velocity of droplets
-    REAL(wp) ::  x                  !< dummy argument for horizontal particle interpolation 
+    REAL(wp) ::  x                  !< dummy argument for horizontal particle interpolation
     REAL(wp) ::  xp                 !< calculated particle position in x of predictor step
     REAL(wp) ::  y                  !< dummy argument for horizontal particle interpolation
@@ -3751,16 +3660,9 @@
     REAL(wp) ::  zp                 !< calculated particle position in z of predictor step
 
-    REAL(wp), PARAMETER ::  a_rog = 9.65_wp      !< parameter for fall velocity
-    REAL(wp), PARAMETER ::  b_rog = 10.43_wp     !< parameter for fall velocity
-    REAL(wp), PARAMETER ::  c_rog = 0.6_wp       !< parameter for fall velocity
-    REAL(wp), PARAMETER ::  k_cap_rog = 4.0_wp   !< parameter for fall velocity
-    REAL(wp), PARAMETER ::  k_low_rog = 12.0_wp  !< parameter for fall velocity
-    REAL(wp), PARAMETER ::  d0_rog = 0.745_wp    !< separation diameter
-
-    REAL(wp), DIMENSION(number_of_particles) ::  term_1_2       !< flag to communicate whether a particle is near topography or not
-    REAL(wp), DIMENSION(number_of_particles) ::  dens_ratio     !< ratio between the density of the fluid and the density of the particles 
     REAL(wp), DIMENSION(number_of_particles) ::  de_dx_int      !< horizontal TKE gradient along x at particle position
     REAL(wp), DIMENSION(number_of_particles) ::  de_dy_int      !< horizontal TKE gradient along y at particle position
     REAL(wp), DIMENSION(number_of_particles) ::  de_dz_int      !< horizontal TKE gradient along z at particle position
+    REAL(wp), DIMENSION(number_of_particles) ::  dens_ratio     !< ratio between the density of the fluid and the density of the
+                                                                !< particles
     REAL(wp), DIMENSION(number_of_particles) ::  diss_int       !< dissipation at particle position
     REAL(wp), DIMENSION(number_of_particles) ::  dt_gap         !< remaining time until particle time integration reaches LES time
@@ -3772,6 +3674,7 @@
     REAL(wp), DIMENSION(number_of_particles) ::  rvar2_temp     !< SGS particle velocity - v-component
     REAL(wp), DIMENSION(number_of_particles) ::  rvar3_temp     !< SGS particle velocity - w-component
+    REAL(wp), DIMENSION(number_of_particles) ::  term_1_2       !< flag to communicate whether a particle is near topography or not
     REAL(wp), DIMENSION(number_of_particles) ::  u_int          !< u-component of particle speed
-    REAL(wp), DIMENSION(number_of_particles) ::  v_int          !< v-component of particle speed 
+    REAL(wp), DIMENSION(number_of_particles) ::  v_int          !< v-component of particle speed
     REAL(wp), DIMENSION(number_of_particles) ::  w_int          !< w-component of particle speed
     REAL(wp), DIMENSION(number_of_particles) ::  xv             !< x-position
@@ -3783,8 +3686,7 @@
     CALL cpu_log( log_point_s(44), 'lpm_advec', 'continue' )
 !
-!-- Determine height of Prandtl layer and distance between Prandtl-layer
-!-- height and horizontal mean roughness height, which are required for
-!-- vertical logarithmic interpolation of horizontal particle speeds
-!-- (for particles below first vertical grid level).
+!-- Determine height of Prandtl layer and distance between Prandtl-layer height and horizontal mean
+!-- roughness height, which are required for vertical logarithmic interpolation of horizontal
+!-- particle speeds (for particles below first vertical grid level).
     z_p      = zu(nzb+1) - zw(nzb)
     d_z_p_z0 = 1.0_wp / ( z_p - z0_av_global )
@@ -3796,12 +3698,11 @@
 
 !
-!-- This case uses a simple interpolation method for the particle velocites,
-!-- and applying a predictor-corrector method. @note the current time divergence
-!-- free time step is denoted with u_t etc.; the velocities of the time level of
-!-- t+1 wit u,v, and w, as the model is called after swap timelevel
+!-- This case uses a simple interpolation method for the particle velocites, and applying a
+!-- predictor-corrector method. @note the current time divergence free time step is denoted with
+!-- u_t etc.; the velocities of the time level of t+1 wit u,v, and w, as the model is called after
+!-- swap timelevel
 !-- @attention: for the corrector step the velocities of t(n+1) are required.
-!-- Therefore the particle code is executed at the end of the time intermediate
-!-- timestep routine. This interpolation method is described in more detail
-!-- in Grabowski et al., 2018 (GMD).
+!-- Therefore the particle code is executed at the end of the time intermediate timestep routine.
+!-- This interpolation method is described in more detail in Grabowski et al., 2018 (GMD).
     IF ( interpolation_simple_corrector )  THEN
 !
@@ -3816,6 +3717,6 @@
           v_int(n) = v_t(kp,jp,ip) * ( 1.0_wp - beta ) + v_t(kp,jp+1,ip) * beta
 
-          gamma = MAX( MIN( ( particles(n)%z - zw(kkw) ) /                   &
-                            ( zw(kkw+1) - zw(kkw) ), 1.0_wp ), 0.0_wp )
+          gamma = MAX( MIN( ( particles(n)%z - zw(kkw) ) / ( zw(kkw+1) - zw(kkw) ), 1.0_wp ),      &
+                       0.0_wp )
           w_int(n) = w_t(kkw,jp,ip) * ( 1.0_wp - gamma ) + w_t(kkw+1,jp,ip) * gamma
 
@@ -3845,23 +3746,22 @@
 !--          z_direction
              k_next = MAX( MIN( FLOOR( zp / (zw(kkw+1)-zw(kkw)) + offset_ocean_nzt ), nzt ), 0)
-             gamma = MAX( MIN( ( zp - zw(k_next) ) /                      &
+             gamma = MAX( MIN( ( zp - zw(k_next) ) /                                               &
                                ( zw(k_next+1) - zw(k_next) ), 1.0_wp ), 0.0_wp )
 !
 !--          Calculate part of the corrector step
-             unext = u(k_next+1, j_next, i_next) * ( 1.0_wp - alpha ) +    &
+             unext = u(k_next+1, j_next, i_next) * ( 1.0_wp - alpha ) +                            &
                      u(k_next+1, j_next,   i_next+1) * alpha
 
-             vnext = v(k_next+1, j_next, i_next) * ( 1.0_wp - beta  ) +    &
+             vnext = v(k_next+1, j_next, i_next) * ( 1.0_wp - beta  ) +                            &
                      v(k_next+1, j_next+1, i_next  ) * beta
 
-             wnext = w(k_next,   j_next, i_next) * ( 1.0_wp - gamma ) +    &
+             wnext = w(k_next,   j_next, i_next) * ( 1.0_wp - gamma ) +                            &
                      w(k_next+1, j_next, i_next  ) * gamma
 
 !
-!--          Calculate interpolated particle velocity with predictor
-!--          corrector step. u_int, v_int and w_int describes the part of
-!--          the predictor step. unext, vnext and wnext is the part of the
-!--          corrector step. The resulting new position is set below. The
-!--          implementation is based on Grabowski et al., 2018 (GMD).
+!--          Calculate interpolated particle velocity with predictor corrector step. u_int, v_int
+!--          and w_int describes the part of the predictor step. unext, vnext and wnext is the part
+!--          of the corrector step. The resulting new position is set below. The implementation is
+!--          based on Grabowski et al., 2018 (GMD).
              u_int(n) = 0.5_wp * ( u_int(n) + unext )
              v_int(n) = 0.5_wp * ( v_int(n) + vnext )
@@ -3871,6 +3771,6 @@
        ENDDO
 !
-!-- This case uses a simple interpolation method for the particle velocites,
-!-- and applying a predictor.
+!-- This case uses a simple interpolation method for the particle velocites, and applying a
+!-- predictor.
     ELSEIF ( interpolation_simple_predictor )  THEN
 !
@@ -3886,6 +3786,6 @@
           v_int(n) = v(kp,jp,ip) * ( 1.0_wp - beta ) + v(kp,jp+1,ip) * beta
 
-          gamma    = MAX( MIN( ( particles(n)%z - zw(kkw) ) /                   &
-                               ( zw(kkw+1) - zw(kkw) ), 1.0_wp ), 0.0_wp )
+          gamma    = MAX( MIN( ( particles(n)%z - zw(kkw) ) / ( zw(kkw+1) - zw(kkw) ), 1.0_wp ),   &
+                          0.0_wp )
           w_int(n) = w(kkw,jp,ip) * ( 1.0_wp - gamma ) + w(kkw+1,jp,ip) * gamma
        ENDDO
@@ -3907,11 +3807,10 @@
 !
 !--          Interpolation of the u velocity component onto particle position.
-!--          Particles are interpolation bi-linearly in the horizontal and a
-!--          linearly in the vertical. An exception is made for particles below
-!--          the first vertical grid level in case of a prandtl layer. In this
-!--          case the horizontal particle velocity components are determined using
-!--          Monin-Obukhov relations (if branch).
-!--          First, check if particle is located below first vertical grid level
-!--          above topography (Prandtl-layer height)
+!--          Particles are interpolation bi-linearly in the horizontal and a linearly in the
+!--          vertical. An exception is made for particles below the first vertical grid level in
+!--          case of a prandtl layer. In this case the horizontal particle velocity components are
+!--          determined using Monin-Obukhov relations (if branch).
+!--          First, check if particle is located below first vertical grid level above topography
+!--          (Prandtl-layer height).
 !--          Determine vertical index of topography top
              k_wall = topo_top_ind(jp,ip,0)
